#-----------------------------------------------------------------------
# Copyright 2006, TIG
# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted, provided the above
# copyright notice appear in all copies.
# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#-----------------------------------------------------------------------
# Name        : ReGlue
# Description : A Tool to ReGlue Components to a [recreated] Face.			
# Menu Item   : Plugins -> ReGlue
# Context Menu: N/A
# Author      : TIG
# Usage       : Select ONE Face and ONE [or MORE] UnGlued Component[s].
#				        Use with care - because by picking a Component and an 
#				        unconnected Face you can 'UnGlue' it and 'ReGlue' it 
#				        onto this new Face even if it's not actually on the same 
#				        plane or at the same rotation !
# Type        : Tool
# Version     :	1.0	27/12/06	First issue.
#-----------------------------------------------------------------------
require 'sketchup.rb'
class ReGlue
def ReGlue::do
  model=Sketchup.active_model;model.start_operation"ReGlue";ss=model.selection
def status(txt)
  Sketchup::set_status_text(txt,SB_PROMPT);Sketchup::set_status_text(" ",SB_VCB_LABEL);Sketchup::set_status_text(" ",SB_VCB_VALUE)
end#def status
def error(txt)
  status("REGLUE: ERROR...");UI.beep;UI.messagebox(txt);return nil
end#def error
faces=[];comps=[]
ss.each{|e|faces.push(e)if e.typename=="Face";comps.push(e)if e.typename=="ComponentInstance"}
return error("ReGlue:\nNO Selection !")if ss.empty?
return error("ReGlue:\nSelection MUST contain at least ONE Face !")if not faces[0]
return error("ReGlue:\nSelection MUST contain NO MORE THAN ONE Face !")if faces[1]
return error("ReGlue:\nSelection MUST contain at least ONE Component !")if not comps[0]
face=faces[0];comps.each{|comp|comp.glued_to=face}
model.commit_operation
end#def
end#class
#-----------------------------------------------------------------------
if(not file_loaded?("Re_Glue.rb"))###
  UI.menu("Plugins").add_item("ReGlue"){ReGlue::do}
end
file_loaded("Re_Glue.rb")###
#-----------------------------------------------------------------------
